// $ANTLR 3.0.1 /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g 2008-12-13 13:34:54
 package org.fabric3.admin.cli; 

import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

/**
 * Fabric3
 * Copyright  2008 Metaform Systems Limited
 *
 * The Antlr grammar for the domain admin interpreter.
 */
public class DomainAdminParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "STORE_CMD", "INSTALL_CMD", "DEPLOY_CMD", "UNDEPLOY_CMD", "UNINSTALL_CMD", "PROVISION_CMD", "REMOVE_CMD", "AUTH_CMD", "STAT_CMD", "USE_CMD", "PARAMETER", "PARAM_USERNAME", "PARAM_PASSWORD", "FILE", "PARAM_CONTRIBUTION_NAME", "PARAM_DOMAIN_NAME", "PARAM_PLAN_NAME", "PARAM_PLAN_FILE", "NEWLINE", "STORE", "WS", "INSTALL", "AUTH", "STAT", "DEPLOY", "PROVISION", "UNDEPLOY", "UNINSTALL", "REMOVE", "USE", "STRING", "USERNAME", "PASSWORD", "CONTRIBUTION", "PLAN"
    };
    public static final int STAT=27;
    public static final int PARAM_DOMAIN_NAME=19;
    public static final int WS=24;
    public static final int STRING=34;
    public static final int STAT_CMD=12;
    public static final int STORE=23;
    public static final int REMOVE=32;
    public static final int AUTH=26;
    public static final int PARAM_CONTRIBUTION_NAME=18;
    public static final int PARAM_PASSWORD=16;
    public static final int STORE_CMD=4;
    public static final int DEPLOY_CMD=6;
    public static final int INSTALL_CMD=5;
    public static final int PARAM_USERNAME=15;
    public static final int NEWLINE=22;
    public static final int PARAM_PLAN_FILE=21;
    public static final int USE_CMD=13;
    public static final int REMOVE_CMD=10;
    public static final int PLAN=38;
    public static final int PASSWORD=36;
    public static final int USERNAME=35;
    public static final int FILE=17;
    public static final int AUTH_CMD=11;
    public static final int EOF=-1;
    public static final int PARAM_PLAN_NAME=20;
    public static final int USE=33;
    public static final int INSTALL=25;
    public static final int PROVISION_CMD=9;
    public static final int PARAMETER=14;
    public static final int DEPLOY=28;
    public static final int CONTRIBUTION=37;
    public static final int UNDEPLOY_CMD=7;
    public static final int PROVISION=29;
    public static final int UNINSTALL=31;
    public static final int UNINSTALL_CMD=8;
    public static final int UNDEPLOY=30;

        public DomainAdminParser(TokenStream input) {
            super(input);
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g"; }



       protected void mismatch(IntStream input, int ttype, BitSet follow) throws RecognitionException {
          super.mismatch(input, ttype, follow);
          // throw new MismatchedTokenException(ttype, input);
       }

       public void recoverFromMismatchedSet(IntStream input, RecognitionException e, BitSet follow) throws RecognitionException {
          super.recoverFromMismatchedSet(input, e, follow);
          // throw e;
       }



    public static class command_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start command
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:58:1: command : ( subcommand )+ EOF ;
    public final command_return command() throws RecognitionException {
        command_return retval = new command_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF2=null;
        subcommand_return subcommand1 = null;


        CommonTree EOF2_tree=null;

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:58:10: ( ( subcommand )+ EOF )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:58:12: ( subcommand )+ EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:58:12: ( subcommand )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==STORE||(LA1_0>=INSTALL && LA1_0<=USE)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:58:13: subcommand
            	    {
            	    pushFollow(FOLLOW_subcommand_in_command238);
            	    subcommand1=subcommand();
            	    _fsp--;

            	    adaptor.addChild(root_0, subcommand1.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            EOF2=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_command242); 
            EOF2_tree = (CommonTree)adaptor.create(EOF2);
            adaptor.addChild(root_0, EOF2_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end command

    public static class subcommand_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start subcommand
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:1: subcommand : ( store | install | deploy | auth | stat | undeploy | uninstall | remove | use | provision ) ( NEWLINE )? ;
    public final subcommand_return subcommand() throws RecognitionException {
        subcommand_return retval = new subcommand_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NEWLINE13=null;
        store_return store3 = null;

        install_return install4 = null;

        deploy_return deploy5 = null;

        auth_return auth6 = null;

        stat_return stat7 = null;

        undeploy_return undeploy8 = null;

        uninstall_return uninstall9 = null;

        remove_return remove10 = null;

        use_return use11 = null;

        provision_return provision12 = null;


        CommonTree NEWLINE13_tree=null;

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:12: ( ( store | install | deploy | auth | stat | undeploy | uninstall | remove | use | provision ) ( NEWLINE )? )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:14: ( store | install | deploy | auth | stat | undeploy | uninstall | remove | use | provision ) ( NEWLINE )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:14: ( store | install | deploy | auth | stat | undeploy | uninstall | remove | use | provision )
            int alt2=10;
            switch ( input.LA(1) ) {
            case STORE:
                {
                alt2=1;
                }
                break;
            case INSTALL:
                {
                alt2=2;
                }
                break;
            case DEPLOY:
                {
                alt2=3;
                }
                break;
            case AUTH:
                {
                alt2=4;
                }
                break;
            case STAT:
                {
                alt2=5;
                }
                break;
            case UNDEPLOY:
                {
                alt2=6;
                }
                break;
            case UNINSTALL:
                {
                alt2=7;
                }
                break;
            case REMOVE:
                {
                alt2=8;
                }
                break;
            case USE:
                {
                alt2=9;
                }
                break;
            case PROVISION:
                {
                alt2=10;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("60:14: ( store | install | deploy | auth | stat | undeploy | uninstall | remove | use | provision )", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:15: store
                    {
                    pushFollow(FOLLOW_store_in_subcommand251);
                    store3=store();
                    _fsp--;

                    adaptor.addChild(root_0, store3.getTree());

                    }
                    break;
                case 2 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:23: install
                    {
                    pushFollow(FOLLOW_install_in_subcommand255);
                    install4=install();
                    _fsp--;

                    adaptor.addChild(root_0, install4.getTree());

                    }
                    break;
                case 3 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:33: deploy
                    {
                    pushFollow(FOLLOW_deploy_in_subcommand259);
                    deploy5=deploy();
                    _fsp--;

                    adaptor.addChild(root_0, deploy5.getTree());

                    }
                    break;
                case 4 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:42: auth
                    {
                    pushFollow(FOLLOW_auth_in_subcommand263);
                    auth6=auth();
                    _fsp--;

                    adaptor.addChild(root_0, auth6.getTree());

                    }
                    break;
                case 5 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:49: stat
                    {
                    pushFollow(FOLLOW_stat_in_subcommand267);
                    stat7=stat();
                    _fsp--;

                    adaptor.addChild(root_0, stat7.getTree());

                    }
                    break;
                case 6 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:56: undeploy
                    {
                    pushFollow(FOLLOW_undeploy_in_subcommand271);
                    undeploy8=undeploy();
                    _fsp--;

                    adaptor.addChild(root_0, undeploy8.getTree());

                    }
                    break;
                case 7 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:67: uninstall
                    {
                    pushFollow(FOLLOW_uninstall_in_subcommand275);
                    uninstall9=uninstall();
                    _fsp--;

                    adaptor.addChild(root_0, uninstall9.getTree());

                    }
                    break;
                case 8 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:79: remove
                    {
                    pushFollow(FOLLOW_remove_in_subcommand279);
                    remove10=remove();
                    _fsp--;

                    adaptor.addChild(root_0, remove10.getTree());

                    }
                    break;
                case 9 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:88: use
                    {
                    pushFollow(FOLLOW_use_in_subcommand283);
                    use11=use();
                    _fsp--;

                    adaptor.addChild(root_0, use11.getTree());

                    }
                    break;
                case 10 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:94: provision
                    {
                    pushFollow(FOLLOW_provision_in_subcommand287);
                    provision12=provision();
                    _fsp--;

                    adaptor.addChild(root_0, provision12.getTree());

                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:105: ( NEWLINE )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==NEWLINE) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:60:105: NEWLINE
                    {
                    NEWLINE13=(Token)input.LT(1);
                    match(input,NEWLINE,FOLLOW_NEWLINE_in_subcommand290); 
                    NEWLINE13_tree = (CommonTree)adaptor.create(NEWLINE13);
                    adaptor.addChild(root_0, NEWLINE13_tree);


                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end subcommand

    public static class store_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start store
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:1: store : STORE file ( WS )? ( param )* -> ^( STORE_CMD file ( param )* ) ;
    public final store_return store() throws RecognitionException {
        store_return retval = new store_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STORE14=null;
        Token WS16=null;
        file_return file15 = null;

        param_return param17 = null;


        CommonTree STORE14_tree=null;
        CommonTree WS16_tree=null;
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleTokenStream stream_STORE=new RewriteRuleTokenStream(adaptor,"token STORE");
        RewriteRuleSubtreeStream stream_file=new RewriteRuleSubtreeStream(adaptor,"rule file");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:15: ( STORE file ( WS )? ( param )* -> ^( STORE_CMD file ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:17: STORE file ( WS )? ( param )*
            {
            STORE14=(Token)input.LT(1);
            match(input,STORE,FOLLOW_STORE_in_store308); 
            stream_STORE.add(STORE14);

            pushFollow(FOLLOW_file_in_store310);
            file15=file();
            _fsp--;

            stream_file.add(file15.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:28: ( WS )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==WS) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:28: WS
                    {
                    WS16=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_store312); 
                    stream_WS.add(WS16);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:32: ( param )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( ((LA5_0>=USERNAME && LA5_0<=CONTRIBUTION)) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:32: param
            	    {
            	    pushFollow(FOLLOW_param_in_store315);
            	    param17=param();
            	    _fsp--;

            	    stream_param.add(param17.getTree());

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            // AST REWRITE
            // elements: file, param
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 63:39: -> ^( STORE_CMD file ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:42: ^( STORE_CMD file ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(STORE_CMD, "STORE_CMD"), root_1);

                adaptor.addChild(root_1, stream_file.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:63:59: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end store

    public static class install_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start install
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:1: install : INSTALL contribution_name ( WS )? ( param )* -> ^( INSTALL_CMD contribution_name ( param )* ) ;
    public final install_return install() throws RecognitionException {
        install_return retval = new install_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token INSTALL18=null;
        Token WS20=null;
        contribution_name_return contribution_name19 = null;

        param_return param21 = null;


        CommonTree INSTALL18_tree=null;
        CommonTree WS20_tree=null;
        RewriteRuleTokenStream stream_INSTALL=new RewriteRuleTokenStream(adaptor,"token INSTALL");
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        RewriteRuleSubtreeStream stream_contribution_name=new RewriteRuleSubtreeStream(adaptor,"rule contribution_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:14: ( INSTALL contribution_name ( WS )? ( param )* -> ^( INSTALL_CMD contribution_name ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:16: INSTALL contribution_name ( WS )? ( param )*
            {
            INSTALL18=(Token)input.LT(1);
            match(input,INSTALL,FOLLOW_INSTALL_in_install339); 
            stream_INSTALL.add(INSTALL18);

            pushFollow(FOLLOW_contribution_name_in_install341);
            contribution_name19=contribution_name();
            _fsp--;

            stream_contribution_name.add(contribution_name19.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:42: ( WS )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==WS) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:42: WS
                    {
                    WS20=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_install343); 
                    stream_WS.add(WS20);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:46: ( param )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>=USERNAME && LA7_0<=CONTRIBUTION)) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:46: param
            	    {
            	    pushFollow(FOLLOW_param_in_install346);
            	    param21=param();
            	    _fsp--;

            	    stream_param.add(param21.getTree());

            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            // AST REWRITE
            // elements: contribution_name, param
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 64:53: -> ^( INSTALL_CMD contribution_name ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:56: ^( INSTALL_CMD contribution_name ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(INSTALL_CMD, "INSTALL_CMD"), root_1);

                adaptor.addChild(root_1, stream_contribution_name.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:64:88: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end install

    public static class auth_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start auth
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:65:1: auth : AUTH auth_param auth_param -> ^( AUTH_CMD auth_param auth_param ) ;
    public final auth_return auth() throws RecognitionException {
        auth_return retval = new auth_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token AUTH22=null;
        auth_param_return auth_param23 = null;

        auth_param_return auth_param24 = null;


        CommonTree AUTH22_tree=null;
        RewriteRuleTokenStream stream_AUTH=new RewriteRuleTokenStream(adaptor,"token AUTH");
        RewriteRuleSubtreeStream stream_auth_param=new RewriteRuleSubtreeStream(adaptor,"rule auth_param");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:65:17: ( AUTH auth_param auth_param -> ^( AUTH_CMD auth_param auth_param ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:65:19: AUTH auth_param auth_param
            {
            AUTH22=(Token)input.LT(1);
            match(input,AUTH,FOLLOW_AUTH_in_auth376); 
            stream_AUTH.add(AUTH22);

            pushFollow(FOLLOW_auth_param_in_auth378);
            auth_param23=auth_param();
            _fsp--;

            stream_auth_param.add(auth_param23.getTree());
            pushFollow(FOLLOW_auth_param_in_auth380);
            auth_param24=auth_param();
            _fsp--;

            stream_auth_param.add(auth_param24.getTree());

            // AST REWRITE
            // elements: auth_param, auth_param
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 65:46: -> ^( AUTH_CMD auth_param auth_param )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:65:49: ^( AUTH_CMD auth_param auth_param )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(AUTH_CMD, "AUTH_CMD"), root_1);

                adaptor.addChild(root_1, stream_auth_param.next());
                adaptor.addChild(root_1, stream_auth_param.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end auth

    public static class stat_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start stat
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:1: stat : STAT ( auth_param )* -> ^( STAT_CMD ( auth_param )* ) ;
    public final stat_return stat() throws RecognitionException {
        stat_return retval = new stat_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STAT25=null;
        auth_param_return auth_param26 = null;


        CommonTree STAT25_tree=null;
        RewriteRuleTokenStream stream_STAT=new RewriteRuleTokenStream(adaptor,"token STAT");
        RewriteRuleSubtreeStream stream_auth_param=new RewriteRuleSubtreeStream(adaptor,"rule auth_param");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:17: ( STAT ( auth_param )* -> ^( STAT_CMD ( auth_param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:19: STAT ( auth_param )*
            {
            STAT25=(Token)input.LT(1);
            match(input,STAT,FOLLOW_STAT_in_stat408); 
            stream_STAT.add(STAT25);

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:24: ( auth_param )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( ((LA8_0>=USERNAME && LA8_0<=PASSWORD)) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:24: auth_param
            	    {
            	    pushFollow(FOLLOW_auth_param_in_stat410);
            	    auth_param26=auth_param();
            	    _fsp--;

            	    stream_auth_param.add(auth_param26.getTree());

            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);


            // AST REWRITE
            // elements: auth_param
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 66:36: -> ^( STAT_CMD ( auth_param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:39: ^( STAT_CMD ( auth_param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(STAT_CMD, "STAT_CMD"), root_1);

                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:66:50: ( auth_param )*
                while ( stream_auth_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_auth_param.next());

                }
                stream_auth_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end stat

    public static class deploy_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start deploy
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:1: deploy : DEPLOY contribution_name ( plan_name )? ( plan_file )? ( WS )? ( param )* -> ^( DEPLOY_CMD contribution_name ( plan_name )? ( plan_file )? ( param )* ) ;
    public final deploy_return deploy() throws RecognitionException {
        deploy_return retval = new deploy_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token DEPLOY27=null;
        Token WS31=null;
        contribution_name_return contribution_name28 = null;

        plan_name_return plan_name29 = null;

        plan_file_return plan_file30 = null;

        param_return param32 = null;


        CommonTree DEPLOY27_tree=null;
        CommonTree WS31_tree=null;
        RewriteRuleTokenStream stream_DEPLOY=new RewriteRuleTokenStream(adaptor,"token DEPLOY");
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleSubtreeStream stream_plan_name=new RewriteRuleSubtreeStream(adaptor,"rule plan_name");
        RewriteRuleSubtreeStream stream_plan_file=new RewriteRuleSubtreeStream(adaptor,"rule plan_file");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        RewriteRuleSubtreeStream stream_contribution_name=new RewriteRuleSubtreeStream(adaptor,"rule contribution_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:14: ( DEPLOY contribution_name ( plan_name )? ( plan_file )? ( WS )? ( param )* -> ^( DEPLOY_CMD contribution_name ( plan_name )? ( plan_file )? ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:16: DEPLOY contribution_name ( plan_name )? ( plan_file )? ( WS )? ( param )*
            {
            DEPLOY27=(Token)input.LT(1);
            match(input,DEPLOY,FOLLOW_DEPLOY_in_deploy433); 
            stream_DEPLOY.add(DEPLOY27);

            pushFollow(FOLLOW_contribution_name_in_deploy435);
            contribution_name28=contribution_name();
            _fsp--;

            stream_contribution_name.add(contribution_name28.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:41: ( plan_name )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==STRING) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:41: plan_name
                    {
                    pushFollow(FOLLOW_plan_name_in_deploy437);
                    plan_name29=plan_name();
                    _fsp--;

                    stream_plan_name.add(plan_name29.getTree());

                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:53: ( plan_file )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==PLAN) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:53: plan_file
                    {
                    pushFollow(FOLLOW_plan_file_in_deploy441);
                    plan_file30=plan_file();
                    _fsp--;

                    stream_plan_file.add(plan_file30.getTree());

                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:64: ( WS )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==WS) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:64: WS
                    {
                    WS31=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_deploy444); 
                    stream_WS.add(WS31);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:68: ( param )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( ((LA12_0>=USERNAME && LA12_0<=CONTRIBUTION)) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:68: param
            	    {
            	    pushFollow(FOLLOW_param_in_deploy447);
            	    param32=param();
            	    _fsp--;

            	    stream_param.add(param32.getTree());

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);


            // AST REWRITE
            // elements: plan_file, param, contribution_name, plan_name
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 67:75: -> ^( DEPLOY_CMD contribution_name ( plan_name )? ( plan_file )? ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:78: ^( DEPLOY_CMD contribution_name ( plan_name )? ( plan_file )? ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(DEPLOY_CMD, "DEPLOY_CMD"), root_1);

                adaptor.addChild(root_1, stream_contribution_name.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:109: ( plan_name )?
                if ( stream_plan_name.hasNext() ) {
                    adaptor.addChild(root_1, stream_plan_name.next());

                }
                stream_plan_name.reset();
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:120: ( plan_file )?
                if ( stream_plan_file.hasNext() ) {
                    adaptor.addChild(root_1, stream_plan_file.next());

                }
                stream_plan_file.reset();
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:67:131: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end deploy

    public static class provision_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start provision
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:1: provision : PROVISION file ( plan_name )? ( plan_file )? ( WS )? ( param )* -> ^( PROVISION_CMD file ( plan_name )? ( plan_file )? ( param )* ) ;
    public final provision_return provision() throws RecognitionException {
        provision_return retval = new provision_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PROVISION33=null;
        Token WS37=null;
        file_return file34 = null;

        plan_name_return plan_name35 = null;

        plan_file_return plan_file36 = null;

        param_return param38 = null;


        CommonTree PROVISION33_tree=null;
        CommonTree WS37_tree=null;
        RewriteRuleTokenStream stream_PROVISION=new RewriteRuleTokenStream(adaptor,"token PROVISION");
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleSubtreeStream stream_file=new RewriteRuleSubtreeStream(adaptor,"rule file");
        RewriteRuleSubtreeStream stream_plan_name=new RewriteRuleSubtreeStream(adaptor,"rule plan_name");
        RewriteRuleSubtreeStream stream_plan_file=new RewriteRuleSubtreeStream(adaptor,"rule plan_file");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:17: ( PROVISION file ( plan_name )? ( plan_file )? ( WS )? ( param )* -> ^( PROVISION_CMD file ( plan_name )? ( plan_file )? ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:19: PROVISION file ( plan_name )? ( plan_file )? ( WS )? ( param )*
            {
            PROVISION33=(Token)input.LT(1);
            match(input,PROVISION,FOLLOW_PROVISION_in_provision478); 
            stream_PROVISION.add(PROVISION33);

            pushFollow(FOLLOW_file_in_provision480);
            file34=file();
            _fsp--;

            stream_file.add(file34.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:34: ( plan_name )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==STRING) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:34: plan_name
                    {
                    pushFollow(FOLLOW_plan_name_in_provision482);
                    plan_name35=plan_name();
                    _fsp--;

                    stream_plan_name.add(plan_name35.getTree());

                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:46: ( plan_file )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==PLAN) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:46: plan_file
                    {
                    pushFollow(FOLLOW_plan_file_in_provision486);
                    plan_file36=plan_file();
                    _fsp--;

                    stream_plan_file.add(plan_file36.getTree());

                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:57: ( WS )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==WS) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:57: WS
                    {
                    WS37=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_provision489); 
                    stream_WS.add(WS37);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:61: ( param )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( ((LA16_0>=USERNAME && LA16_0<=CONTRIBUTION)) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:61: param
            	    {
            	    pushFollow(FOLLOW_param_in_provision492);
            	    param38=param();
            	    _fsp--;

            	    stream_param.add(param38.getTree());

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            // AST REWRITE
            // elements: plan_name, param, file, plan_file
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 68:68: -> ^( PROVISION_CMD file ( plan_name )? ( plan_file )? ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:71: ^( PROVISION_CMD file ( plan_name )? ( plan_file )? ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PROVISION_CMD, "PROVISION_CMD"), root_1);

                adaptor.addChild(root_1, stream_file.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:92: ( plan_name )?
                if ( stream_plan_name.hasNext() ) {
                    adaptor.addChild(root_1, stream_plan_name.next());

                }
                stream_plan_name.reset();
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:104: ( plan_file )?
                if ( stream_plan_file.hasNext() ) {
                    adaptor.addChild(root_1, stream_plan_file.next());

                }
                stream_plan_file.reset();
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:68:116: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end provision

    public static class undeploy_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start undeploy
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:1: undeploy : UNDEPLOY contribution_name ( WS )? ( param )* -> ^( UNDEPLOY_CMD contribution_name ( param )* ) ;
    public final undeploy_return undeploy() throws RecognitionException {
        undeploy_return retval = new undeploy_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token UNDEPLOY39=null;
        Token WS41=null;
        contribution_name_return contribution_name40 = null;

        param_return param42 = null;


        CommonTree UNDEPLOY39_tree=null;
        CommonTree WS41_tree=null;
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleTokenStream stream_UNDEPLOY=new RewriteRuleTokenStream(adaptor,"token UNDEPLOY");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        RewriteRuleSubtreeStream stream_contribution_name=new RewriteRuleSubtreeStream(adaptor,"rule contribution_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:15: ( UNDEPLOY contribution_name ( WS )? ( param )* -> ^( UNDEPLOY_CMD contribution_name ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:17: UNDEPLOY contribution_name ( WS )? ( param )*
            {
            UNDEPLOY39=(Token)input.LT(1);
            match(input,UNDEPLOY,FOLLOW_UNDEPLOY_in_undeploy524); 
            stream_UNDEPLOY.add(UNDEPLOY39);

            pushFollow(FOLLOW_contribution_name_in_undeploy526);
            contribution_name40=contribution_name();
            _fsp--;

            stream_contribution_name.add(contribution_name40.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:44: ( WS )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==WS) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:44: WS
                    {
                    WS41=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_undeploy528); 
                    stream_WS.add(WS41);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:48: ( param )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( ((LA18_0>=USERNAME && LA18_0<=CONTRIBUTION)) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:48: param
            	    {
            	    pushFollow(FOLLOW_param_in_undeploy531);
            	    param42=param();
            	    _fsp--;

            	    stream_param.add(param42.getTree());

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);


            // AST REWRITE
            // elements: param, contribution_name
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 69:55: -> ^( UNDEPLOY_CMD contribution_name ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:58: ^( UNDEPLOY_CMD contribution_name ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(UNDEPLOY_CMD, "UNDEPLOY_CMD"), root_1);

                adaptor.addChild(root_1, stream_contribution_name.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:69:91: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end undeploy

    public static class uninstall_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start uninstall
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:1: uninstall : UNINSTALL contribution_name ( WS )? ( param )* -> ^( UNINSTALL_CMD contribution_name ( param )* ) ;
    public final uninstall_return uninstall() throws RecognitionException {
        uninstall_return retval = new uninstall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token UNINSTALL43=null;
        Token WS45=null;
        contribution_name_return contribution_name44 = null;

        param_return param46 = null;


        CommonTree UNINSTALL43_tree=null;
        CommonTree WS45_tree=null;
        RewriteRuleTokenStream stream_UNINSTALL=new RewriteRuleTokenStream(adaptor,"token UNINSTALL");
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        RewriteRuleSubtreeStream stream_contribution_name=new RewriteRuleSubtreeStream(adaptor,"rule contribution_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:16: ( UNINSTALL contribution_name ( WS )? ( param )* -> ^( UNINSTALL_CMD contribution_name ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:18: UNINSTALL contribution_name ( WS )? ( param )*
            {
            UNINSTALL43=(Token)input.LT(1);
            match(input,UNINSTALL,FOLLOW_UNINSTALL_in_uninstall555); 
            stream_UNINSTALL.add(UNINSTALL43);

            pushFollow(FOLLOW_contribution_name_in_uninstall557);
            contribution_name44=contribution_name();
            _fsp--;

            stream_contribution_name.add(contribution_name44.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:46: ( WS )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==WS) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:46: WS
                    {
                    WS45=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_uninstall559); 
                    stream_WS.add(WS45);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:50: ( param )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);

                if ( ((LA20_0>=USERNAME && LA20_0<=CONTRIBUTION)) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:50: param
            	    {
            	    pushFollow(FOLLOW_param_in_uninstall562);
            	    param46=param();
            	    _fsp--;

            	    stream_param.add(param46.getTree());

            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);


            // AST REWRITE
            // elements: param, contribution_name
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 70:57: -> ^( UNINSTALL_CMD contribution_name ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:60: ^( UNINSTALL_CMD contribution_name ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(UNINSTALL_CMD, "UNINSTALL_CMD"), root_1);

                adaptor.addChild(root_1, stream_contribution_name.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:70:94: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end uninstall

    public static class remove_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start remove
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:1: remove : REMOVE contribution_name ( WS )? ( param )* -> ^( REMOVE_CMD contribution_name ( param )* ) ;
    public final remove_return remove() throws RecognitionException {
        remove_return retval = new remove_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token REMOVE47=null;
        Token WS49=null;
        contribution_name_return contribution_name48 = null;

        param_return param50 = null;


        CommonTree REMOVE47_tree=null;
        CommonTree WS49_tree=null;
        RewriteRuleTokenStream stream_REMOVE=new RewriteRuleTokenStream(adaptor,"token REMOVE");
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleSubtreeStream stream_param=new RewriteRuleSubtreeStream(adaptor,"rule param");
        RewriteRuleSubtreeStream stream_contribution_name=new RewriteRuleSubtreeStream(adaptor,"rule contribution_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:17: ( REMOVE contribution_name ( WS )? ( param )* -> ^( REMOVE_CMD contribution_name ( param )* ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:19: REMOVE contribution_name ( WS )? ( param )*
            {
            REMOVE47=(Token)input.LT(1);
            match(input,REMOVE,FOLLOW_REMOVE_in_remove590); 
            stream_REMOVE.add(REMOVE47);

            pushFollow(FOLLOW_contribution_name_in_remove592);
            contribution_name48=contribution_name();
            _fsp--;

            stream_contribution_name.add(contribution_name48.getTree());
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:44: ( WS )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==WS) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:44: WS
                    {
                    WS49=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_remove594); 
                    stream_WS.add(WS49);


                    }
                    break;

            }

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:48: ( param )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( ((LA22_0>=USERNAME && LA22_0<=CONTRIBUTION)) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:48: param
            	    {
            	    pushFollow(FOLLOW_param_in_remove597);
            	    param50=param();
            	    _fsp--;

            	    stream_param.add(param50.getTree());

            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);


            // AST REWRITE
            // elements: param, contribution_name
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 71:55: -> ^( REMOVE_CMD contribution_name ( param )* )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:58: ^( REMOVE_CMD contribution_name ( param )* )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(REMOVE_CMD, "REMOVE_CMD"), root_1);

                adaptor.addChild(root_1, stream_contribution_name.next());
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:71:89: ( param )*
                while ( stream_param.hasNext() ) {
                    adaptor.addChild(root_1, stream_param.next());

                }
                stream_param.reset();

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end remove

    public static class use_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start use
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:72:1: use : USE domain_name -> ^( USE_CMD domain_name ) ;
    public final use_return use() throws RecognitionException {
        use_return retval = new use_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token USE51=null;
        domain_name_return domain_name52 = null;


        CommonTree USE51_tree=null;
        RewriteRuleTokenStream stream_USE=new RewriteRuleTokenStream(adaptor,"token USE");
        RewriteRuleSubtreeStream stream_domain_name=new RewriteRuleSubtreeStream(adaptor,"rule domain_name");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:72:17: ( USE domain_name -> ^( USE_CMD domain_name ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:72:19: USE domain_name
            {
            USE51=(Token)input.LT(1);
            match(input,USE,FOLLOW_USE_in_use628); 
            stream_USE.add(USE51);

            pushFollow(FOLLOW_domain_name_in_use630);
            domain_name52=domain_name();
            _fsp--;

            stream_domain_name.add(domain_name52.getTree());

            // AST REWRITE
            // elements: domain_name
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 72:35: -> ^( USE_CMD domain_name )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:72:38: ^( USE_CMD domain_name )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(USE_CMD, "USE_CMD"), root_1);

                adaptor.addChild(root_1, stream_domain_name.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end use

    public static class file_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start file
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:73:1: file : STRING -> ^( FILE STRING ) ;
    public final file_return file() throws RecognitionException {
        file_return retval = new file_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING53=null;

        CommonTree STRING53_tree=null;
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:73:11: ( STRING -> ^( FILE STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:73:13: STRING
            {
            STRING53=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_file650); 
            stream_STRING.add(STRING53);


            // AST REWRITE
            // elements: STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 73:20: -> ^( FILE STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:73:23: ^( FILE STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(FILE, "FILE"), root_1);

                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end file

    public static class param_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start param
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:1: param : operator STRING ( WS )? -> ^( PARAMETER operator STRING ) ;
    public final param_return param() throws RecognitionException {
        param_return retval = new param_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING55=null;
        Token WS56=null;
        operator_return operator54 = null;


        CommonTree STRING55_tree=null;
        CommonTree WS56_tree=null;
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_operator=new RewriteRuleSubtreeStream(adaptor,"rule operator");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:12: ( operator STRING ( WS )? -> ^( PARAMETER operator STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:14: operator STRING ( WS )?
            {
            pushFollow(FOLLOW_operator_in_param670);
            operator54=operator();
            _fsp--;

            stream_operator.add(operator54.getTree());
            STRING55=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_param672); 
            stream_STRING.add(STRING55);

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:30: ( WS )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==WS) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:30: WS
                    {
                    WS56=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_param674); 
                    stream_WS.add(WS56);


                    }
                    break;

            }


            // AST REWRITE
            // elements: STRING, operator
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 74:34: -> ^( PARAMETER operator STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:74:37: ^( PARAMETER operator STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAMETER, "PARAMETER"), root_1);

                adaptor.addChild(root_1, stream_operator.next());
                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end param

    public static class auth_param_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start auth_param
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:1: auth_param : auth_operator STRING ( WS )? -> ^( PARAMETER auth_operator STRING ) ;
    public final auth_param_return auth_param() throws RecognitionException {
        auth_param_return retval = new auth_param_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING58=null;
        Token WS59=null;
        auth_operator_return auth_operator57 = null;


        CommonTree STRING58_tree=null;
        CommonTree WS59_tree=null;
        RewriteRuleTokenStream stream_WS=new RewriteRuleTokenStream(adaptor,"token WS");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_auth_operator=new RewriteRuleSubtreeStream(adaptor,"rule auth_operator");
        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:16: ( auth_operator STRING ( WS )? -> ^( PARAMETER auth_operator STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:18: auth_operator STRING ( WS )?
            {
            pushFollow(FOLLOW_auth_operator_in_auth_param697);
            auth_operator57=auth_operator();
            _fsp--;

            stream_auth_operator.add(auth_operator57.getTree());
            STRING58=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_auth_param699); 
            stream_STRING.add(STRING58);

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:39: ( WS )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==WS) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:39: WS
                    {
                    WS59=(Token)input.LT(1);
                    match(input,WS,FOLLOW_WS_in_auth_param701); 
                    stream_WS.add(WS59);


                    }
                    break;

            }


            // AST REWRITE
            // elements: STRING, auth_operator
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 75:43: -> ^( PARAMETER auth_operator STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:75:46: ^( PARAMETER auth_operator STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAMETER, "PARAMETER"), root_1);

                adaptor.addChild(root_1, stream_auth_operator.next());
                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end auth_param

    public static class operator_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start operator
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:1: operator : ( username | password | contribution ) ;
    public final operator_return operator() throws RecognitionException {
        operator_return retval = new operator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        username_return username60 = null;

        password_return password61 = null;

        contribution_return contribution62 = null;



        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:17: ( ( username | password | contribution ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:19: ( username | password | contribution )
            {
            root_0 = (CommonTree)adaptor.nil();

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:19: ( username | password | contribution )
            int alt25=3;
            switch ( input.LA(1) ) {
            case USERNAME:
                {
                alt25=1;
                }
                break;
            case PASSWORD:
                {
                alt25=2;
                }
                break;
            case CONTRIBUTION:
                {
                alt25=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("76:19: ( username | password | contribution )", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:20: username
                    {
                    pushFollow(FOLLOW_username_in_operator728);
                    username60=username();
                    _fsp--;

                    adaptor.addChild(root_0, username60.getTree());

                    }
                    break;
                case 2 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:31: password
                    {
                    pushFollow(FOLLOW_password_in_operator732);
                    password61=password();
                    _fsp--;

                    adaptor.addChild(root_0, password61.getTree());

                    }
                    break;
                case 3 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:76:42: contribution
                    {
                    pushFollow(FOLLOW_contribution_in_operator736);
                    contribution62=contribution();
                    _fsp--;

                    adaptor.addChild(root_0, contribution62.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end operator

    public static class auth_operator_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start auth_operator
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:1: auth_operator : ( username | password ) ;
    public final auth_operator_return auth_operator() throws RecognitionException {
        auth_operator_return retval = new auth_operator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        username_return username63 = null;

        password_return password64 = null;



        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:17: ( ( username | password ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:19: ( username | password )
            {
            root_0 = (CommonTree)adaptor.nil();

            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:19: ( username | password )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==USERNAME) ) {
                alt26=1;
            }
            else if ( (LA26_0==PASSWORD) ) {
                alt26=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("77:19: ( username | password )", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:20: username
                    {
                    pushFollow(FOLLOW_username_in_auth_operator747);
                    username63=username();
                    _fsp--;

                    adaptor.addChild(root_0, username63.getTree());

                    }
                    break;
                case 2 :
                    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:77:31: password
                    {
                    pushFollow(FOLLOW_password_in_auth_operator751);
                    password64=password();
                    _fsp--;

                    adaptor.addChild(root_0, password64.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end auth_operator

    public static class username_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start username
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:78:1: username : USERNAME -> ^( PARAM_USERNAME ) ;
    public final username_return username() throws RecognitionException {
        username_return retval = new username_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token USERNAME65=null;

        CommonTree USERNAME65_tree=null;
        RewriteRuleTokenStream stream_USERNAME=new RewriteRuleTokenStream(adaptor,"token USERNAME");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:78:17: ( USERNAME -> ^( PARAM_USERNAME ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:78:19: USERNAME
            {
            USERNAME65=(Token)input.LT(1);
            match(input,USERNAME,FOLLOW_USERNAME_in_username766); 
            stream_USERNAME.add(USERNAME65);


            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 78:28: -> ^( PARAM_USERNAME )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:78:31: ^( PARAM_USERNAME )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_USERNAME, "PARAM_USERNAME"), root_1);

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end username

    public static class password_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start password
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:79:1: password : PASSWORD -> ^( PARAM_PASSWORD ) ;
    public final password_return password() throws RecognitionException {
        password_return retval = new password_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PASSWORD66=null;

        CommonTree PASSWORD66_tree=null;
        RewriteRuleTokenStream stream_PASSWORD=new RewriteRuleTokenStream(adaptor,"token PASSWORD");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:79:17: ( PASSWORD -> ^( PARAM_PASSWORD ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:79:19: PASSWORD
            {
            PASSWORD66=(Token)input.LT(1);
            match(input,PASSWORD,FOLLOW_PASSWORD_in_password786); 
            stream_PASSWORD.add(PASSWORD66);


            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 79:28: -> ^( PARAM_PASSWORD )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:79:31: ^( PARAM_PASSWORD )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_PASSWORD, "PARAM_PASSWORD"), root_1);

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end password

    public static class contribution_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contribution
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:80:1: contribution : CONTRIBUTION -> ^( PARAM_CONTRIBUTION_NAME ) ;
    public final contribution_return contribution() throws RecognitionException {
        contribution_return retval = new contribution_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token CONTRIBUTION67=null;

        CommonTree CONTRIBUTION67_tree=null;
        RewriteRuleTokenStream stream_CONTRIBUTION=new RewriteRuleTokenStream(adaptor,"token CONTRIBUTION");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:80:17: ( CONTRIBUTION -> ^( PARAM_CONTRIBUTION_NAME ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:80:19: CONTRIBUTION
            {
            CONTRIBUTION67=(Token)input.LT(1);
            match(input,CONTRIBUTION,FOLLOW_CONTRIBUTION_in_contribution802); 
            stream_CONTRIBUTION.add(CONTRIBUTION67);


            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 80:32: -> ^( PARAM_CONTRIBUTION_NAME )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:80:35: ^( PARAM_CONTRIBUTION_NAME )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_CONTRIBUTION_NAME, "PARAM_CONTRIBUTION_NAME"), root_1);

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end contribution

    public static class contribution_name_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contribution_name
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:81:1: contribution_name : STRING -> ^( PARAM_CONTRIBUTION_NAME STRING ) ;
    public final contribution_name_return contribution_name() throws RecognitionException {
        contribution_name_return retval = new contribution_name_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING68=null;

        CommonTree STRING68_tree=null;
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:81:19: ( STRING -> ^( PARAM_CONTRIBUTION_NAME STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:81:21: STRING
            {
            STRING68=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_contribution_name815); 
            stream_STRING.add(STRING68);


            // AST REWRITE
            // elements: STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 81:28: -> ^( PARAM_CONTRIBUTION_NAME STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:81:31: ^( PARAM_CONTRIBUTION_NAME STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_CONTRIBUTION_NAME, "PARAM_CONTRIBUTION_NAME"), root_1);

                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end contribution_name

    public static class domain_name_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start domain_name
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:82:1: domain_name : STRING -> ^( PARAM_DOMAIN_NAME STRING ) ;
    public final domain_name_return domain_name() throws RecognitionException {
        domain_name_return retval = new domain_name_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING69=null;

        CommonTree STRING69_tree=null;
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:82:17: ( STRING -> ^( PARAM_DOMAIN_NAME STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:82:19: STRING
            {
            STRING69=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_domain_name834); 
            stream_STRING.add(STRING69);


            // AST REWRITE
            // elements: STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 82:26: -> ^( PARAM_DOMAIN_NAME STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:82:29: ^( PARAM_DOMAIN_NAME STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_DOMAIN_NAME, "PARAM_DOMAIN_NAME"), root_1);

                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end domain_name

    public static class plan_name_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start plan_name
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:83:1: plan_name : STRING -> ^( PARAM_PLAN_NAME STRING ) ;
    public final plan_name_return plan_name() throws RecognitionException {
        plan_name_return retval = new plan_name_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token STRING70=null;

        CommonTree STRING70_tree=null;
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:83:17: ( STRING -> ^( PARAM_PLAN_NAME STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:83:19: STRING
            {
            STRING70=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_plan_name855); 
            stream_STRING.add(STRING70);


            // AST REWRITE
            // elements: STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 83:26: -> ^( PARAM_PLAN_NAME STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:83:29: ^( PARAM_PLAN_NAME STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_PLAN_NAME, "PARAM_PLAN_NAME"), root_1);

                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end plan_name

    public static class plan_file_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start plan_file
    // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:84:1: plan_file : PLAN STRING -> ^( PARAM_PLAN_FILE STRING ) ;
    public final plan_file_return plan_file() throws RecognitionException {
        plan_file_return retval = new plan_file_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PLAN71=null;
        Token STRING72=null;

        CommonTree PLAN71_tree=null;
        CommonTree STRING72_tree=null;
        RewriteRuleTokenStream stream_PLAN=new RewriteRuleTokenStream(adaptor,"token PLAN");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:84:17: ( PLAN STRING -> ^( PARAM_PLAN_FILE STRING ) )
            // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:84:19: PLAN STRING
            {
            PLAN71=(Token)input.LT(1);
            match(input,PLAN,FOLLOW_PLAN_in_plan_file876); 
            stream_PLAN.add(PLAN71);

            STRING72=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_plan_file878); 
            stream_STRING.add(STRING72);


            // AST REWRITE
            // elements: STRING
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 84:31: -> ^( PARAM_PLAN_FILE STRING )
            {
                // /Users/meerajk/fabric3/modules/trunk/target/checkout/admin/fabric3-admin-grammar/src/main/antlr/org/fabric3/admin/cli/DomainAdmin.g:84:34: ^( PARAM_PLAN_FILE STRING )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(adaptor.create(PARAM_PLAN_FILE, "PARAM_PLAN_FILE"), root_1);

                adaptor.addChild(root_1, stream_STRING.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

           catch (RecognitionException e) {
              throw e;
           }
        finally {
        }
        return retval;
    }
    // $ANTLR end plan_file


 

    public static final BitSet FOLLOW_subcommand_in_command238 = new BitSet(new long[]{0x00000003FE800000L});
    public static final BitSet FOLLOW_EOF_in_command242 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_store_in_subcommand251 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_install_in_subcommand255 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_deploy_in_subcommand259 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_auth_in_subcommand263 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_stat_in_subcommand267 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_undeploy_in_subcommand271 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_uninstall_in_subcommand275 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_remove_in_subcommand279 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_use_in_subcommand283 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_provision_in_subcommand287 = new BitSet(new long[]{0x0000000000400002L});
    public static final BitSet FOLLOW_NEWLINE_in_subcommand290 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STORE_in_store308 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_file_in_store310 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_store312 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_store315 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_INSTALL_in_install339 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_contribution_name_in_install341 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_install343 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_install346 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_AUTH_in_auth376 = new BitSet(new long[]{0x0000001800000000L});
    public static final BitSet FOLLOW_auth_param_in_auth378 = new BitSet(new long[]{0x0000001800000000L});
    public static final BitSet FOLLOW_auth_param_in_auth380 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAT_in_stat408 = new BitSet(new long[]{0x0000001800000002L});
    public static final BitSet FOLLOW_auth_param_in_stat410 = new BitSet(new long[]{0x0000001800000002L});
    public static final BitSet FOLLOW_DEPLOY_in_deploy433 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_contribution_name_in_deploy435 = new BitSet(new long[]{0x0000007C01000002L});
    public static final BitSet FOLLOW_plan_name_in_deploy437 = new BitSet(new long[]{0x0000007801000002L});
    public static final BitSet FOLLOW_plan_file_in_deploy441 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_deploy444 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_deploy447 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_PROVISION_in_provision478 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_file_in_provision480 = new BitSet(new long[]{0x0000007C01000002L});
    public static final BitSet FOLLOW_plan_name_in_provision482 = new BitSet(new long[]{0x0000007801000002L});
    public static final BitSet FOLLOW_plan_file_in_provision486 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_provision489 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_provision492 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_UNDEPLOY_in_undeploy524 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_contribution_name_in_undeploy526 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_undeploy528 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_undeploy531 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_UNINSTALL_in_uninstall555 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_contribution_name_in_uninstall557 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_uninstall559 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_uninstall562 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_REMOVE_in_remove590 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_contribution_name_in_remove592 = new BitSet(new long[]{0x0000003801000002L});
    public static final BitSet FOLLOW_WS_in_remove594 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_param_in_remove597 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_USE_in_use628 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_domain_name_in_use630 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_file650 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_operator_in_param670 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_STRING_in_param672 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_WS_in_param674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_auth_operator_in_auth_param697 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_STRING_in_auth_param699 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_WS_in_auth_param701 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_username_in_operator728 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_password_in_operator732 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_contribution_in_operator736 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_username_in_auth_operator747 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_password_in_auth_operator751 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_USERNAME_in_username766 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PASSWORD_in_password786 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTRIBUTION_in_contribution802 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_contribution_name815 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_domain_name834 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_plan_name855 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLAN_in_plan_file876 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_STRING_in_plan_file878 = new BitSet(new long[]{0x0000000000000002L});

}